using BepInEx.Configuration;

using UnityEngine;

using System;
using System.Reflection;

namespace WBM
{
    public partial class WBM
    {
        private ConfigEntry<bool> useOldGunSoundConf;

        private FieldInfo oldGunSoundRef;
        private AudioClip oldGunSoundRaw
        {
            get
            {
                return ((HKPCKNFOBNA)this.oldGunSoundRef.GetValue(this.webguy)).DDKAHAAKKME;
            }
        }
        private AudioClip oldGunSound;

        private FieldInfo AKSoundRef;
        private HKPCKNFOBNA AKSoundRaw
        {
            get
            {
                return (HKPCKNFOBNA)this.AKSoundRef.GetValue(this.webguy);
            }
            set
            {
                this.AKSoundRef.SetValue(this.webguy, value);
            }
        }
        private AudioClip newAKSound;

        private FieldInfo SMGSoundRef;
        private HKPCKNFOBNA SMGSoundRaw
        {
            get
            {
                return (HKPCKNFOBNA)this.SMGSoundRef.GetValue(this.webguy);
            }
            set
            {
                this.SMGSoundRef.SetValue(this.webguy, value);
            }
        }
        private AudioClip newSMGSound;

        private void setupOldGunSound()
        {
            this.oldGunSoundRef = webguyType.GetField("ICMCDLNEIAI", bindFlags);
            this.AKSoundRef = webguyType.GetField("DGEJAAPKEAD", bindFlags);
            this.SMGSoundRef = webguyType.GetField("OFAALIJFKEI", bindFlags);

            this.useOldGunSoundConf = Config.Bind("Config", "use old gun sound", true);
            this.useOldGunSoundConf.SettingChanged += this.onOldGunSoundChange;
            this.onOldGunSoundChange(new object(), new EventArgs());

            this.oldGunSound = this.oldGunSoundRaw;
            this.newAKSound = this.AKSoundRaw.DDKAHAAKKME;
            this.newSMGSound = this.SMGSoundRaw.DDKAHAAKKME;
        }

        private void onOldGunSoundChange(object sender, EventArgs e)
        {
            if (this.useOldGunSoundConf.Value)
            {
                this.AKSoundRaw.DDKAHAAKKME = this.oldGunSound;
                this.SMGSoundRaw.DDKAHAAKKME = this.oldGunSound;
            }
            else
            {
                this.AKSoundRaw.DDKAHAAKKME = this.newAKSound;
                this.SMGSoundRaw.DDKAHAAKKME = this.newSMGSound;
            }
        }
    }
}
